/*  IPTalk - A P2P Communications System for IP Networks
		Version 1.0
		(C) 2001 Kevin H. Patterson
		IPTalk Version 1.0 is distributed under the GNU General Public License.
		Please see the included file "GPL License.txt" for details.
*/

#ifndef _clsNetEndpointA_h
#define _clsNetEndpointA_h

#include <Application.h>
#include <NetEndpoint.h>
#include <Looper.h>
#include <Locker.h>
#include <String.h>
#include <Alert.h>

class NetEndpointA
:
	public BNetEndpoint
{
	public:
		NetEndpointA(int Protocol = SOCK_STREAM);
		NetEndpointA(const BNetEndpoint &NetEndpoint);
		NetEndpointA(BMessage * Archive);
		
		BLooper * Target;
		
		BLocker Locker;
				
		BString LocalHost();
		uint16 LocalPort();
		BString RemoteHost();
		uint16 RemotePort();
		
		bool ShowAlerts;
		
		bool volatile Listening;
		bool StartListening();
		bool StopListening();

		bool volatile Receiving;
		bool StartReceiving();
		bool StopReceiving();
		
		virtual int32 SendA(const void * buffer, size_t size, int flags = 0);
	private:
		void AlertInitCheck();
		void AlertResolveLocalAddress();
		void AlertResolveRemoteAddress();
		
		thread_id ListenerThreadID;
		thread_id ReceiverThreadID;
};

#endif