/*  IPTalk - A P2P Communications System for IP Networks
		Version 1.0
		(C) 2001 Kevin H. Patterson
		IPTalk Version 1.0 is distributed under the GNU General Public License.
		Please see the included file "GPL License.txt" for details.
*/

#ifndef _clsChatWindow_h
#define _clsChatWindow_h

#include <stdlib.h>

#include <Application.h>
#include <Window.h>
#include <View.h>
#include <TextControl.h>
#include <ScrollView.h>
#include <Button.h>
#include <Alert.h>
#include <String.h>

#include <NetEndpoint.h>

#include "NetEndpointA.h"

#include "clsConnectedTextView.h"

int32 const StateDisconnected = 0;
int32 const StateConnected = 1;
int32 const StateConnecting = 2;
int32 const StateAuto = -1;

class clsChatWindow
:
	public BWindow
{
	public:
		clsChatWindow();
		clsChatWindow(BNetEndpoint * NewConnection);
		virtual bool QuitRequested();
		virtual void MessageReceived(BMessage* Message);
		virtual void FrameResized(float width, float height);
		bool TransitionState(int32 NewState = StateAuto);
	private:
    int32 ConnectionState;
    NetEndpointA * Connection;
		BView * MainView;
			BView * ConnectionView;
				float TopClip;
				BTextControl * ConnectIP;
				BTextControl * ConnectPort;
				BButton * ConnectButton;
			BView * InTextView;
				clsConnectedTextView * InText;
			BView * OutTextView;
				clsConnectedTextView * OutText;
		bool SetupViews();
};

#endif
