/*  IPTalk - A P2P Communications System for IP Networks
		Version 1.0
		(C) 2001 Kevin H. Patterson
		IPTalk Version 1.0 is distributed under the GNU General Public License.
		Please see the included file "GPL License.txt" for details.
*/

#include "clsConnectedTextView.h"

clsConnectedTextView::clsConnectedTextView
(
	BRect frame, const char *name, BRect textRect,
	uint32 resizingMode, uint32 flags
)
:
	BTextView::BTextView(frame, name, textRect, resizingMode, flags)
{
	Connected = false;
}

void clsConnectedTextView::MessageReceived(BMessage* Message)
{
	switch(Message->what)
	{
	default:
	  BTextView::MessageReceived(Message);
	}
}

void clsConnectedTextView::InsertText
(
	const char * text,
	int32 length,
	int32 offset,
	const text_run_array * runs
)
{
	if (Connected)
	{
	  BMessage * MyMessage = new BMessage('TIns');
	  MyMessage->AddInt32("offset", offset);
	  MyMessage->AddInt32("length", length);
	  MyMessage->AddString("text", text);
	  ChatWindow->PostMessage(MyMessage);
	  delete MyMessage;	
	}
  BTextView::InsertText(text, length, offset, runs);
}

void clsConnectedTextView::DeleteText(int32 start, int32 finish)
{
	if (Connected)
	{
	  BMessage * MyMessage = new BMessage('TDel');
	  MyMessage->AddInt32("start", start);
	  MyMessage->AddInt32("finish", finish);
	  ChatWindow->PostMessage(MyMessage);
	  delete MyMessage;	
	}
	BTextView::DeleteText(start,finish);
}
